#include <iostream>
#include <fstream>
#include <cstdlib>
#include <time.h>
#include <string>
using namespace std;

int main()
{
	string *nouns = NULL;
	string *adjectives = NULL;

	string *verbs = NULL;
	string *adverbs = NULL;

	string *articles = NULL;
	string *prepositions = NULL;

	string *conjunctions = NULL;

	string input;
	int value, i, j,
		nouncount = 0, adjcount = 0,
		verbcount = 0, advcount = 0,
		artcount  = 0, prepcount = 0, conjcount = 0;

	ofstream fout;
	fout.open("output.txt");

	//Read in words
	ifstream fin;

	fin.open("input.txt");
	fin >> input;

	while( !fin.eof() )
	{
		if( stricmp( input.c_str(), "<nouns" ) == 0 )
		{
			fin >> input;
			value = strtoul( input.c_str(), NULL, 10 );
			nouncount = value;
			nouns = new string[value];
			for( i = 0; i < value; i++ )
			{
				fin >> input;
				nouns[i] = input;
			}
		} else if( stricmp( input.c_str(), "<adjectives" ) == 0 )
		{
			fin >> input;
			value = strtoul( input.c_str(), NULL, 10 );
			adjcount = value;
			adjectives = new string[value];
			for( i = 0; i < value; i++ )
			{
				fin >> input;
				adjectives[i] = input;
			}
		} else if ( stricmp( input.c_str(), "<verbs" ) == 0 )
		{
			fin >> input;
			value = strtoul( input.c_str(), NULL, 10 );
			verbcount = value;
			verbs = new string[value];
			for( i = 0; i < value; i++ )
			{
				fin >> input;
				verbs[i] = input;
			}
		} else if( stricmp( input.c_str(), "<adverbs" ) == 0 )
		{
			fin >> input;
			value = strtoul( input.c_str(), NULL, 10 );
			advcount = value;
			adverbs = new string[value];
			for( i = 0; i < value; i++ )
			{
				fin >> input;
				adverbs[i] = input;
			}
		} else if( stricmp( input.c_str(), "<articles" ) == 0 )
		{
			fin >> input;
			value = strtoul( input.c_str(), NULL, 10 );
			artcount = value;
			articles = new string[value];
			for( i = 0; i < value; i++ )
			{
				fin >> input;
				articles[i] = input;
			}

		} else if( stricmp( input.c_str(), "<prepositions" ) == 0 )
		{
			fin >> input;
			value = strtoul( input.c_str(), NULL, 10 );
			prepcount = value;
			prepositions = new string[value];
			for( i = 0; i < value; i++ )
			{
				fin >> input;
				prepositions[i] = input;
			}
		} else if( stricmp( input.c_str(), "<conjunctions" ) == 0 )
		{
			fin >> input;
			value = strtoul( input.c_str(), NULL, 10 );
			conjcount = value;
			conjunctions = new string[value];
			for( i = 0; i < value; i++ )
			{
				fin >> input;
				conjunctions[i] = input;
			}
		}
		fin >> input;
	}

	cout << nouncount << " Nouns" << endl;
	for( i = 0; i < nouncount; i++)	cout << nouns[i] << endl;

	cout << adjcount << " Adjectives" << endl;
	for( i = 0; i < adjcount; i++)	cout << adjectives[i] << endl;

	cout << verbcount << " Verbs" << endl;
	for( i = 0; i < verbcount; i++)	cout << verbs[i] << endl;

	cout << advcount << " Adverbs" << endl;
	for( i = 0; i < advcount; i++)	cout << adverbs[i] << endl;

	cout << artcount << " Articles" << endl;
	for( i = 0; i < artcount; i++)	cout << articles[i] << endl;

	cout << prepcount << " Prepositions" << endl;
	for( i = 0; i < prepcount; i++)	cout << prepositions[i] << endl;

	cout << conjcount << " Conjunctions" << endl;
	for( i = 0; i < conjcount; i++)	cout << conjunctions[i] << endl;

	srand( (unsigned)time( NULL ) );

	cout << "\t";

	for( j = 0; j < 48; j++ )
	{
		if( rand()%2 )
		{
			fout << ' ' << articles[rand()%artcount];
			fout << ' ' << adjectives[rand()%adjcount];
		}
		fout << ' ' << nouns[rand()%nouncount];

		if( rand()%2 )
			fout << ' ' << adverbs[rand()%advcount];

		fout << ' ' << verbs[rand()%verbcount];

		if( rand()%2 )
		{
			fout << ' ' << articles[rand()%artcount];
			fout << ' ' << adjectives[rand()%adjcount];
		}
		fout << ' ' << nouns[rand()%nouncount];

		if( rand()%2 )
			fout << ' ' << conjunctions[rand()%conjcount];
		else
		{
			fout << '.';
			if ( rand()%2 ) fout << endl << "\t";
		}
	}

	if( nouns != NULL )	delete [] nouns;
	if( adjectives != NULL ) delete [] adjectives;

	if( verbs != NULL ) delete [] verbs;
	if( adverbs != NULL ) delete [] adverbs;

	if( articles != NULL ) delete [] articles;
	if( prepositions != NULL ) delete [] prepositions;

	if( conjunctions != NULL ) delete [] conjunctions;

	return 0;
}